#!/usr/bin/env python3
def coerce(f):
    annotation = f.__annotations__
    parameters = f.__code__.co_varnames
    def wrapper(*args, **kwargs):
        # add positional arguments to keyword argument dict
        for i, value in enumerate(args):
            name = parameters[i]
            kwargs[name] = value

        coerced_kwargs=dict()
        for name, value in kwargs.items():
            type = annotation.get(name, None)
            if type is not None:
                try:
                    value = type() if value is None else type(value)
                except TypeError:
                    # If the value can't be coerced leave the value as it is
                    pass
            coerced_kwargs[name] = value

        return f(**coerced_kwargs)
    return wrapper
